posts - 168,  comments - 30,  trackbacks - 0
blogjava网站与博客园合并了,对blogjava还是有感情的。
并且blogjava网站发布的文章是在博客园首页看不到的。
blogjava网站首页能看到,你可以点击标题进入可以看到图片二维码信息。

Java爱好者社区
公众号内容简介:

专注于分享Java后端相关技术、老司机实战干货,不限于JVM、并发、设计模式、性能优化、分布式&微服务、云原生、大数据相关主题。
希望关注的你停下脚步,定有所收获。

以前的个人博客内容不好迁移,所以我打算根据自己的多年经验,不断整理输出有价值的内容。
目前公众号内容有关于SpringCloud(微服务框架)、Skywalking(APM监控调用链)、JVM(GC分析、内存泄漏分析)、并发编程相关原创实战文章已出炉。

最近刚开始已经有不少小伙伴关注了,期待能有幸搜索到本博客的同学,可以扫码关注一下,不胜感激。
大家有任何技术、职场、面试上的问题都可以与我交流。

方式一:扫码以下公众号二维码:


方式二:在微信上直接搜索: javatech_cbo

感谢各位小伙伴的支持,后续会在该公众号上输出大量的有价值的实战干货 ,期待与你一同进步与成长。

posted @ 2020-01-07 18:39 David1228 阅读(348) | 评论 (0)编辑 收藏
blogjava网站与博客园合并了,对blogjava还是有感情的。
并且blogjava网站发布的文章是在博客园首页看不到的。
blogjava网站首页能看到,你可以点击标题进入可以看到图片二维码信息。

Java爱好者社区
公众号内容简介:

专注于分享Java后端相关技术、老司机实战干货,不限于JVM、并发、设计模式、性能优化、分布式&微服务、云原生、大数据相关主题。
希望关注的你停下脚步,定有所收获。

以前的个人博客内容不好迁移,所以我打算根据自己的多年经验,不断整理输出有价值的内容。
目前公众号内容有关于SpringCloud(微服务框架)、Skywalking(APM监控调用链)、JVM(GC分析、内存泄漏分析)、并发编程相关原创实战文章已出炉。

最近刚开始已经有不少小伙伴关注了,期待能有幸搜索到本博客的同学,可以扫码关注一下,不胜感激。
大家有任何技术、职场、面试上的问题都可以与我交流。

方式一:扫码以下公众号二维码:


方式二:在微信上直接搜索: javatech_cbo

感谢各位小伙伴的支持,后续会在该公众号上输出大量的有价值的实战干货 ,期待与你一同进步与成长。

posted @ 2019-10-30 14:10 David1228 阅读(278) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-09-04 16:33 David1228 阅读(142) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-08-02 11:41 David1228 阅读(132) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-07-24 19:10 David1228 阅读(6195) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-07-19 18:10 David1228 阅读(2508) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-06-06 23:10 David1228 阅读(132) | 评论 (0)编辑 收藏
Netty客户端与服务端通信
posted @ 2017-06-06 23:09 David1228 阅读(102) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-05-30 19:26 David1228 阅读(1181) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2017-05-30 19:25 David1228 阅读(1077) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2016-12-22 23:01 David1228 阅读(3259) | 评论 (2)编辑 收藏
     摘要:   阅读全文
posted @ 2016-11-04 23:44 David1228 阅读(2098) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2016-07-28 17:57 David1228 阅读(241) | 评论 (0)编辑 收藏
     摘要: JVM调优总结 + jstat 分析jstat -gccause pid 1 每格1毫秒输出结果jstat -gccause pid 2000 每格2秒输出结果不断的在屏幕打印出结果  S0     S1     E     &n...  阅读全文
posted @ 2016-01-03 23:26 David1228 阅读(2523) | 评论 (2)编辑 收藏
     摘要:   阅读全文
posted @ 2015-12-27 16:49 David1228 阅读(732) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2015-10-31 12:37 David1228 阅读(499) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2015-10-30 20:20 David1228 阅读(2567) | 评论 (0)编辑 收藏
转载文章:http://www.qixing318.com/article/by-lua-adhesive-nginx-ecological-environment.html
posted @ 2015-09-08 13:22 David1228 阅读(380) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2015-09-08 09:34 David1228| 编辑 收藏
     摘要:   阅读全文
posted @ 2015-07-29 13:48 David1228 阅读(5374) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2014-12-03 23:56 David1228 阅读(25875) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2013-11-19 11:48 David1228 阅读(23258) | 评论 (1)编辑 收藏
     摘要:   阅读全文
posted @ 2013-11-18 18:01 David1228 阅读(2749) | 评论 (4)编辑 收藏
     摘要:   阅读全文
posted @ 2013-10-31 17:32 David1228 阅读(564) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2013-10-14 09:50 David1228 阅读(20543) | 评论 (6)编辑 收藏
Hibernate不支持left join带on的条件查询。
解决办法:使用原生SQL或者使用HQL方式需要修改hbm文件(如果项目中大部分不适用级联配置情况下)
需求是查询网络信息,网络信息中关联了分区、网络IP(1个网络--N个网络IP),网桥信息.
HQL:
public void queryVnets(Page page) {
        StringBuffer hql = new StringBuffer();
        hql.append("select new Map(vn.id as id, vn.vnName as vnName, b.name as vnType, ");
        hql.append("vn.vnIptype as vnIptype, vn.vnIp as vnIp,vn.vnNat as vnNat, vn.vnFlag as vnFlag, ");
        hql.append("vn.vnetFlag as vnetFlag, (case when sum(vmvn.state)='0' then 0 else 1 endas vnState, ");
        hql.append("vn.useType as useType, vn.createTime as createTime, ");
        hql .append("zone.oneName as oneName, zone.oneHypervisor as oneHypervisor, zone.oneSeq as oneSeq) ");
        hql.append("from VnetTable vn, ZoneTable zone, BridgeTable b ");
        hql.append("left join fetch vn.VnTables vmvn where zone.id = vn.zoneId and vn.vnType = b.id ");

        ... ...
        hql.append(" group by vn.id");
        if (vnState != null && !"".equals(vnState)) {
            if ("0".equals(vnState)) {
                hql.append(" having sum(vmvn.state)=0");
            } else if ("1".equals(vnState)) {
                hql.append(" having sum(vmvn.state)!=0");
            }
        }
    }

hbm配置文件:
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE hibernate-mapping PUBLIC "-//Hibernate/Hibernate Mapping DTD 3.0//EN"
"http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd">
<!-- 
    Mapping file autogenerated by MyEclipse Persistence Tools
-->
<hibernate-mapping>
    <class name="com.base.mapping.VnetTable" table="vnet_table" >
        <id name="id" type="java.lang.String">
            <column name="ID" length="32" />
            <generator class="uuid.hex" />
        </id>
        <property name="vnId" type="java.lang.Long">
            <column name="VN_ID">
                <comment>创建虚拟网络时得到的ID</comment>
            </column>
        </property>
         ...
        <property name="zoneId" type="java.lang.String">
            <column name="ZONE_ID" length="32">
                <comment>分区ID</comment>
            </column>
        </property>
        <property name="vlanId" type="java.lang.Integer">
            <column name="VLAN_ID">
                <comment>VLAN_ID</comment>
            </column>
        </property>
        <set name="vnTables" lazy="false" order-by="id asc" inverse="false" fetch="join" cascade="all">
            <key column="VN_NID"/>
            <one-to-many class="com.base.mapping.VnTable"/>
        </set>
    </class>
</hibernate-mapping>

理解inverse和cascade,可以参考:http://blog.csdn.net/wkcgy/article/details/6271321
总结: 
<one-to-many>中,建议inverse=”true”,由“many”方来进行关联关系的维护 
<many-to-many>中,只设置其中一方inverse=”false”,或双方都不设置 
Cascade,通常情况下都不会使用。特别是删除,一定要慎重。
操作建议 
  一般对many-to-one和many-to-many不设置级联,这要看业务逻辑的需要;对one-to-one和one-to-many设置级联。
  many-to-many关联关系中,一端设置inverse=”false”,另一端设置为inverse=”true”。在one-to-many关联关系中,设置inverse=”true”,由多端来维护关系表










posted @ 2013-09-12 11:57 David1228 阅读(13104) | 评论 (2)编辑 收藏
-- 以下两个查询效率相当,查询时间均为0.0xx秒,~ 但是Hibernate HQL不支持from后面接子查询,可以直接使用SQL方式解决,ibatis当然可以用了。
SELECT count(*from (
SELECT sum(t2.STATE) as vnSum, t1.ID FROM
vnetinfo_table t1, vm_vn_table t2 
where t1.ID = t2.VN_NID and t1.ZONE_ID = '4028a49c3facdf26013fae12531b286e' GROUP BY t1.ID) t where t.vnSum = 0;

SELECT count(*) FROM vnetinfo_table v ,(
SELECT sum(t2.STATE) as vnSum, t1.ID as idd FROM
vnetinfo_table t1, vm_vn_table t2 
where t1.ID = t2.VN_NID and t1.ZONE_ID = '4028a49c3facdf26013fae12531b286e' GROUP BY t1.ID) t
where v.ID = t.idd and t.vnSum = 0;

-- 查询效率太低了,查询时间均为0.5xx秒左右。要比以上两个SQL耗时很多倍。~ Hibernate支持在where后用子查询作为查询条件。
SELECT count(*) FROM vnetinfo_table v WHERE v.id in 
(SELECT CASE WHEN SUM(t2.STATE)=0 THEN t1.ID ELSE '' END
FROM vnetinfo_table t1, vm_vn_table t2 
where t1.ID = t2.VN_NID and t1.ZONE_ID = '4028a49c3facdf26013fae12531b286e' GROUP BY t1.ID);

-- 使用join方式替换in 查询时间均为0.09x秒左右。明显提高了效率,但是Hibernate HQL任然不支持在这种联合子查询方式。
SELECT count(*) FROM vnetinfo_table v INNER JOIN (SELECT CASE WHEN SUM(t2.STATE)=0 THEN t1.ID ELSE '' END as idd
FROM vnetinfo_table t1, vm_vn_table t2 
WHERE t1.ID = t2.VN_NID and t1.ZONE_ID = '4028a49c3facdf26013fae12531b286e' GROUP BY t1.ID) t ON v.ID = t.idd and t.idd IS not NULL;

附:Mysql中关于Exists用法的介绍请参见:http://www.nowamagic.net/librarys/veda/detail/639
posted @ 2013-08-21 13:47 David1228 阅读(3180) | 评论 (2)编辑 收藏
md5sum命令详解:
linux下的shell命令 ,制作md5码 也用于软件的md5校验
MD5算法常常被用来验证网络文件传输的完整性,防止文件被人篡改。MD5 全称是报文摘要算法(Message-Digest Algorithm 5),此算法对任意长度的信息逐位进行计算,产生一个二进制长度为128位(十六进制长度就是32位)的“指纹”(或称“报文摘要”),不同的文件产生相同的报文摘要的可能性是非常非常之小的。
在linux或Unix上,md5sum是用来计算和校验文件报文摘要的工具程序。一般来说,安装了Linux后,就会有md5sum这个工具,直接在命令行终端直接运行。
1、使用md5sum来产生指纹(报文摘要)命令如下:
md5sum filename > filename.md5 或者
md5sum filename >>filename.md5
也可以把多个文件的报文摘要输出到一个md5文件中,这要使用通配符*,比如某目录下有几个iso文件,要把这几个iso文件的摘要输出到iso.md5文件中,命令如下:
md5sum *.iso > iso.md5
2、使用md5报文摘要验证文件,方法有二:
把下载的文件file和该文件的file.md5报文摘要文件放在同一个目录下,然后用如下命令进行验证:
md5sum -c file.md5
然后如果验证成功,则会输出:正确结果。
实战案例:
需求:虚拟机存在多份备份,当进行备份恢复时,要求检查源备份压缩文件的完整性。那么可以通过md5这种方式来验证。
压缩备份文件并生成md5码,部分shell脚本如下:
#----------------------------------
log "Compressing and moving $SRC_PATH"
exec_and_log "$SSH $SRC_HOST mkdir -p ${SRC_PATH}_compress"
for file in `$SSH $SRC_HOST ls $SRC_PATH | grep -v $SN_SIGN`
do
     exec_and_log "$SSH $SRC_HOST cd $SRC_PATH;sudo chmod -R +r $SRC_PATH/*;tar -Sczvf ${SRC_PATH}_compress/${file}.tgz ${file}"
done
#----------------------------------

#--------------md5 begin-----------------
log "Create backup.md5"
exec_and_log "$SSH $SRC_HOST $MD5SUM ${SRC_PATH}_compress/*.tgz > ${SRC_PATH}_compress/backup.md5"
#--------------md5 end-----------------

#其中 exec_and_log是另一个公共脚本中定义的。shell中可以通过点(.)的方式将脚本引入。该函数内如下:
# Executes a command, if it fails returns error message and exits
# If a second parameter is present it is used as the error message when
# the command fails
function exec_and_log
{
    message=$2

    EXEC_LOG_ERR=`$1 2>&1 1>/dev/null`
    EXEC_LOG_RC=$?

    if [ $EXEC_LOG_RC -ne 0 ]; then
        log_error "Command \"$1\" failed: $EXEC_LOG_ERR"

        if [ -n "$2" ]; then
            error_message "$2"
        else
            error_message "Error executing $1: $EXEC_LOG_ERR"
        fi
        exit $EXEC_LOG_RC
    fi
}

# Logs a message, alias to log_info
function log
{
    log_info "$1"
}

# Log function that knows how to deal with severities and adds the
# script name
function log_function
{
    echo "$1: $SCRIPT_NAME: $2" 1>&2
}

# Logs an info message
function log_info
{
    log_function "INFO" "$1"
}

# Logs an error message
function log_error
{
    log_function "ERROR" "$1"
}

# This function is used to pass error message to the mad
function error_message
{
    (
        echo "ERROR MESSAGE --8<------"
        echo "$1"
        echo "ERROR MESSAGE ------>8--"
    ) 1>&2
}

生成的backup.md5内容:
$ md5sum *.tgz > backup.md5 
2c07174d451a687bc0e401b1dc7d84b8  checkpoint.1376892493.tgz
57a18d7f6eed36565b9012e519985130  checkpoint.1376903188.tgz
b652990806e58a81b41dc1b23db9adda  checkpoint.1376904023.tgz
f4e7adb46a8fde2643e082875cc60e21  checkpoint.1376904289.tgz
ad2a59902652e2896b35507417b7016f  checkpoint.tgz
4bd43eac64f238bb35c7194816da7d23  deployment.0.tgz
ee3d9266cf92f7540cc75a94343bc20a  deployment.7.tgz
fcd5aae37354b5cb66f4b90544eaa5c3  disk.0.tgz
c1ef6d911b441660ec2d1e44b5a56f66  disk.1.iso.tgz
25eae70a31a7c7cff3baade4cd65fe82  disk.1.tgz

检查备份文件是否完整:
exec_and_log "$SSH $SRC_HOST $MD5SUM -c ${SRC_PATH}/backup.md5"

检测结果:
$ md5sum -c backup.md5 
checkpoint.1376892493.tgz: OK
checkpoint.1376903188.tgz: OK
checkpoint.1376904023.tgz: OK
checkpoint.1376904289.tgz: OK
checkpoint.tgz: OK
deployment.0.tgz: OK
deployment.7.tgz: OK
disk.0.tgz: OK
disk.1.iso.tgz: OK
disk.1.tgz: OK
posted @ 2013-08-20 11:34 David1228 阅读(2255) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2013-08-20 09:46 David1228 阅读(278) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2013-08-20 09:44 David1228 阅读(278) | 评论 (0)编辑 收藏
     摘要:   阅读全文
posted @ 2013-07-24 16:11 David1228 阅读(30077) | 评论 (0)编辑 收藏
     摘要: 根据官方的说法,在ibatis3,也就是Mybatis3问世之前,Spring3的开发工作就已经完成了,所以Spring3中还是没有对Mybatis3的支持。因此由Mybatis社区自己开发了一个Mybatis-Spring用来满足Mybatis用户整合Spring的需求。下面就将通过Mybatis-Spring来整合Mybatis跟Spring的用法做一个简单的介绍。MapperFactoryB...  阅读全文
posted @ 2013-07-10 18:07 David1228 阅读(20911) | 评论 (2)编辑 收藏

不得不承认的是,在目前的web应用开发中,Spring的应用越来越广泛,其地位变得相当重要。而在最近推出的Spring 3.2版本中,又引入了一些新的值得关注的特性。本文中将介绍其中一些值得关注的新特性。

一 不再需要web.xml

 在新的Spring 3.2中,可以不再需要web.xml这个文件了,这得益于Servlet 3.0的新特性。

其中,可以使用@WebServlet在需要调用的servlet中,使用注解去设置servlet中的映射关系。这样的话,就可以不再象以往那样要通过在web.xml中对servlet进行配置,十分方便。

此外,Servlet 3.0提供了既能在容器中动态注册servlet的方法,也提供了通过实现

ServletContainerInitializer接口的方法实现在容器启动阶段为容器动态注册Servlet、Filter和listeners。容器会在应用的启动阶段,调用所有实现ServletContainerInitializer接口类中的onStartup()方法。而Spring 3.2中,则进一步简化了这点,只需要实现WebApplicationInitializer接口就可以了,其中提供了一个相关的实现类--AbstractContextLoaderInitializer,它可以动态注册DispatcherServlet。这意味着,只要spring-webmvc.jar放置在web应用的web-inf/lib中,就可以调用Dispatcher servlet了。可以参考如下的例子(来自Spring文档):

  1. public class MyWebApplicationInitializer implements WebApplicationInitializer { 
  2.  
  3.     @Override 
  4.     public void onStartup(ServletContext container) { 
  5.         ServletRegistration.Dynamic registration = container.addServlet("dispatcher"new DispatcherServlet()); 
  6.         registration.setLoadOnStartup(1); 
  7.         registration.addMapping("/example/*"); 
  8.     } 
  9.  

二 支持Java编程式配置在Spring mvc 3.2中,一个不错的特性就是在之前版本中支持使用Java代码配置各种依赖注入的基础上,进一步简化了配置。关于使用Java编程式配置的好处,可以通过下面这个链接文章的介绍去学习

http://blog.frankel.ch/consider-replacing-spring-xml-configuration-with-javaconfig)。
在Spring mvc 3.2中,提供了AbstractContextLoaderInitialize的一个子类AbstractAnnotationConfigDispatcherServletInitializer去实现零XML配置的效果,只需要创建的类继承AbstractAnnotationConfigDispatcherServletInitializer就可以了,如下代码所示:

  1. public  
  2.  
  3. class  
  4.  
  5. SugarSpringWebInitializer extends AbstractAnnotationConfigDispatcherServletInitializer { 
  6.  
  7.     @Override 
  8.     protected Class<?>[] getRootConfigClasses() { 
  9.         return new Class[] { JavaConfig.class }; 
  10.     } 
  11.  
  12.     @Override 
  13.     protected Class<?>[] getServletConfigClasses() { 
  14.         return new Class[] { WebConfig.class }; 
  15.     } 
  16.  
  17.     @Override 
  18.     protected String[] getServletMappings() { 
  19.         return new String[] { "/" }; 
  20.     } 
  21.  

功能更强大的Spring Test 框架现在,单元测试显得越来越重要了,每一个类都建议做好对应的单元测试。在Spring 3.2版本之前,如果要对Spring MVC进行单元测试的话,必须显式去调用某个控制器类中的某个方法,而不能直接单元测试相关的mapping映射。而在Spring mvc 3.2中,重新整合和增强了测试框架的功能,支持直接用/*这样的映射方式去测试某个控制器中的类。同时,之前的开源项目(https://github.com/SpringSource/spring-test-mvc也被收录到Spring mvc 3.2中去了。此外,还新增加了对返回(return),重定向(redirect)model等的测试改进,下面是一个例子:

  1. public class SayHelloControllerIT extends AbstractTestNGSpringContextTests { 
  2.   
  3.     private MockMvc mockMvc; 
  4.   
  5.     @BeforeMethod 
  6.     public void setUp() { 
  7.   
  8.         mockMvc = webAppContextSetup((WebApplicationContext) applicationContext).build(); 
  9.     } 
  10.   
  11.     @Test(dataProvider = "pathParameterAndExpectedModelValue"
  12.     public void accessingSayhelloWithSubpathShouldForwardToSayHelloJspWithModelFilled(String path, String value) throws Exception { 
  13.   
  14.         mockMvc.perform(get("/sayHello/Jo")).andExpect(view().name("sayHello")).andExpect(model().attribute("name""Jo")); 
  15.     } 

本文的示例代码可以在: http://blog.frankel.ch/wp-content/resources/spring-3-2-sweetness/spring-sweet-1.0.0.zip中下载。

原文链接:http://java.dzone.com/articles/spring-32-sweetness

posted @ 2013-07-10 11:48 David1228 阅读(2233) | 评论 (0)编辑 收藏
     摘要: 本文转载自:http://www.cnblogs.com/java-my-life/archive/2012/03/28/2418836.html场景问题  举个生活中常见的例子——组装电脑,我们在组装电脑的时候,通常需要选择一系列的配件,比如CPU、硬盘、内存、主板、电源、机箱等。为讨论使用简单点,只考虑选择CPU和主板的问题。  事实上,在选择CPU的时候,面临一系列的...  阅读全文
posted @ 2013-07-04 17:07 David1228 阅读(265) | 评论 (0)编辑 收藏
shell中可能经常能看到:>/dev/null 2>&1 

命令的结果可以通过%>的形式来定义输出

分解这个组合:“>/dev/null 2>&1” 为五部分。

1:> 代表重定向到哪里,例如:echo "123" > /home/123.txt
2:/dev/null 代表空设备文件
3:2> 表示stderr标准错误
4:& 表示等同于的意思,2>&1,表示2的输出重定向等同于1
5:1 表示stdout标准输出,系统默认值是1,所以">/dev/null"等同于 "1>/dev/null"

因此,>/dev/null 2>&1 也可以写成“1> /dev/null 2> &1”

那么本文标题的语句执行过程为:
1>/dev/null :首先表示标准输出重定向到空设备文件,也就是不输出任何信息到终端,说白了就是不显示任何信息。
2>&1 :接着,标准错误输出重定向 到 标准输出,因为之前标准输出已经重定向到了空设备文件,所以标准错误输出也重定向到空设备文件。

最常用的方式有:
    
command > file 2>file  与command > file 2>&1

它们有什么不同的地方吗?
      首先command > file 2>file 的意思是将命令所产生的标准输出信息,和错误的输出信息送到file 中.command  > file 2>file 这样的写法,stdout和stderr都直接送到file中, file会被打开两次,这样stdout和stderr会互相覆盖,这样写相当使用了FD1和FD2两个同时去抢占file 的管道。
      而command >file 2>&1 这条命令就将stdout直接送向file, stderr 继承了FD1管道后,再被送往file,此时,file 只被打开了一次,也只使用了一个管道FD1,它包括了stdout和stderr的内容。
      从IO效率上,前一条命令的效率要比后面一条的命令效率要低,所以在编写shell脚本的时候,较多的时候我们会command > file 2>&1 这样的写法。
 
以上转载自:http://sjolzy.cn/shell-in-the-dev-null-2-gt-amp-1-Detailed.html

-
-----------------------------------------------------------------------------------------------------
那么,有这么个需求,我如何能判断远程主机上的某个文件是否存在呢,我能想到的有两种方法,一种方法可以使用expect脚本,但是需要远程主机上安装expect包,但是只需要知道用户名和密码就可以了;第二种方法是要求两台主机之间做好ssh互信,然后如admin,那么通过shell可以直接判断,但是文件宿主权限也需要是admin用户下的。
第二种方法脚本如下:
#!/bin/bash

ssh dst_host sh -s 2>&1 1>/dev/null <<EOF
ls $NEW_DST_DIR
EOF
IS_EXIST=$?
if [ "$IS_EXIST"x = "0"x ]; then
   echo "-The file exists------------------------------"
else
   echo "No file-------------------------------"
fi

--大卫





posted @ 2013-07-02 14:45 David1228 阅读(790) | 评论 (0)编辑 收藏
OpenNebula中主机添加一切正常。
执行$onehost list 主机CPU、内存资源可以正常被监控到。但是,创建虚拟机后,虚拟机状态很长一段时间一直处于pend状态。而OpenNebula的mm_sched调度虚拟机的周期是缺省30秒调度一次,根据调度算法适配一台合适的主机,主机是新添加的而且是有足够资源的,为什么不能部署呢?
我们可以通过查看虚拟机的调度日志$ONE_LOCATION/var/sched.log发现如下错误信息:
Tue Feb 21 [HOST][E]: Exception raised: Unable to transport XML to server and get XML response back.
 HTTP response: 504 Tue Feb 22 14:27:39 2011 [POOL][E]: Could not retrieve pool info from ONE。
解决方法:
在OpenNebula官方的Wiki中可以找到原因,原因是所添加的主机使用了HTTP代理上网了,所以OpenNebula读取了系统的http_proxy环境变量,此时就需要关闭http_proxy。

I can create VMs, but sched.log shows the error "Could not retrieve pool info from ONE". What's wrong?

If the scheduler does not deploy the pending VMs, and messages like these are found in sched.log

[HOST][E]: Exception raised: Unable to transport XML to server and get XML response back.  HTTP response code is 404, not 200 [POOL][E]: Could not retrieve pool info from ONE

Then you need to unset the http_proxy environment variable, or set the no_proxy accordingly.

wiki参考地址(这里汇总了使用或部署one过程中可能遇到的问题以及解决办法):http://wiki.opennebula.org/faq#listing_vms_takes_a_lot_of_time_why

大家对于Opennebula的安装部署感兴趣的话,可以参考vpsee的博客(在Centos上安装和部署Opennebula),讲解的很详细。

vpsee已经试玩了下OpenNebula4.0,由于项目原因,目前我们还在用OpenNebula3.8.1,后面也会测试升级到OpenNebula4.0看看新功能。
升级过程同样也参考下vpsee的OpenNebula3.x升级到OpenNebula4.0,^^ 这么好的资源优先借鉴。

posted @ 2013-06-24 18:01 David1228 阅读(680) | 评论 (0)编辑 收藏
启动和停止OpenNebula shell脚本如下:
给这个脚本起个名字吧,叫做oned

#!/bin/bash
#
# chkconfig: 345 80 15
# description: Startup script for the one .

# Source function library.

. /etc/rc.d/init.d/functions

APP_USER=oneadmin
APP_HOME=/opt/nebula/ONE/

RETVAL=0

start(){
        checkrun
        if [ $RETVAL -eq 1 ]; then
                echo "Starting oned"
                su - $APP_USER -c "$APP_HOME/bin/one start"
    else
       echo "oned is already running."

        fi
}

stop(){
        su - $APP_USER -c "$APP_HOME/bin/oneuser list" > /dev/null 2>&1
        result=$?
        if [ $result -eq 0 ]; then

                echo "Shutting down oned"
                su - $APP_USER -c "$APP_HOME/bin/one stop"

        elif [ $result -eq 255 ]; then

                echo "Shutting down oned"
                pkill -9 -u oneadmin

    fi
}
   
checkrun(){
        su - $APP_USER -c "$APP_HOME/bin/oneuser list" > /dev/null 2>&1
        if [ $? -eq 0 ]; then
             RETVAL=0
             return $RETVAL
    else
             RETVAL=1
             return $RETVAL
        fi
}

status(){
        checkrun
        if [ $RETVAL -eq 0 ]; then
                echo "oned is running."
        else
            echo "oned is stopped."
            exit 1
        fi
}

case "$1" in
start)
        start
        RETVAL=$?
        ;;
stop)
        stop
        RETVAL=$?
        ;;
restart)
        stop
        start
        RETVAL=$?
        ;;
status)
        status
        ;;
*)
        echo "Usage: $0 {start|stop|restart|status}"
        esac
echo $RETVAL
exit 0
Linux中如何设置服务开机自启动,可以参考http://os.51cto.com/art/201301/377515.htm

1. 首先查看服务器默认的运行级别是多少? 目的是在对应运行级别下建立服务的软连接。
 1> 执行命令#runlevel
 [root@compute-63-14]# runlevel
 N 3
 2> 查看/etc/inittab
 [root@compute-63-14 tomcat6]# cat /etc/inittab 
 # inittab is only used by upstart for the default runlevel.
 ... ... 
 id:3:initdefault:
 
2. 将写好的oned脚本拷贝到/etc/init.d/目录下

3. 在/etc/rc.d/rc3.d中建立软链接
cd /etc/init.d/rc.d/rc3.d
ln -s ../init.d/oned S99oned
S99oned是其软链接,S开头代表加载时自启动

以上已测试过,没有问题,同时有兴趣可以试试第二、三种方式。
posted @ 2013-06-04 11:18 David1228 阅读(224) | 评论 (0)编辑 收藏
VNCServer X 桌面默认为 twm, 这时连接进去只能看到终端界面,而看不到远程桌面界面。可修改 /root/.vnc/xstartup 文件,将其改为 GNOME KDE 桌面:
GNOME

[root @ test vnc-4_1_2-x86_linux] # vi /root/.vnc/xstartup
#
/bin/sh
[ -r $HOME/.Xresources ] && xrdb $HOME/.Xresources
xsetroot –solid grey
vncconfig –iconic &
xterm –geometry 80x24+10+10 –ls –title “$VNCDESKTOP Desktop” &
gnome-session &

KDE:
[root @ test vnc-4_1_2-x86_linux] # vi /root/.vnc/xstartup
#
/bin/sh
[ -r $HOME/.Xresources ] && xrdb $HOME/.Xresources
xsetroot –solid grey
vncconfig –iconic &
xterm –geometry 80x24+10+10 –ls –title “$VNCDESKTOP Desktop” &
startkde &
修改完毕后须重新启动 VNCServer
[root @ test vnc-4_1_2-x86_linux] # vncserver –kill :1 && vncserver :1
[root @ test vnc-4_1_2-x86_linux] # vncviewer 192.168.98.32:1
连接后即可使用 GNOME KDE 桌面啦(就像 WinXP 的远程桌面一般),也可以通过 WEB 访问,在浏览器中输入http://192.168.0.252:5801 即可,VNC 默认的端口号为5801

转载:http://shaoruisky.blog.163.com/blog/static/92610707201151224518579/
posted @ 2013-03-24 13:07 David1228 阅读(1834) | 评论 (0)编辑 收藏

<2013年3月>
242526272812
3456789
10111213141516
17181920212223
24252627282930
31123456

常用链接

留言簿(3)

随笔分类

随笔档案

文章档案

新闻分类

新闻档案

相册

收藏夹

Java

Linux知识相关

Spring相关

云计算/Linux/虚拟化技术/

友情博客

多线程并发编程

开源技术

持久层技术相关

搜索

  •  

积分与排名

  • 积分 - 310136
  • 排名 - 161

最新评论

阅读排行榜

评论排行榜